from entities.descriptors import UserPinDescriptor
from firmwareconfig import FirmwareConfig as fwcfg


class UserPinList:
    """A class to define the list of user pins of the board"""

    # this class can be actually created only once
    _ready = False

    def __init__(self):
        assert self._ready is False, "Class {} should be created only once!".format(self.__class__.__name__)
        self._create()
        self._ready = True

    def count(self):
        return len(self.vars)

    def entries(self):
        return self.vars

    def _create(self):
        self.vars = list()

        self.vars.append(
            UserPinDescriptor(
                enum_index=1,
                firmware_config=fwcfg,
                name='SWITCH_LED_D9',
                ioname='DOUT_JP1_LED_D9',
                description='Line IN/OUT not assigned. Free line available on JP1 jumper. Usable in output to turn on the LED'
            )
        )
        self.vars.append(
            UserPinDescriptor(
                enum_index=2,
                firmware_config=fwcfg,
                name='SWITCH_LED_D10',
                ioname='DOUT_JP2_LED_D10',
                description='Line IN/OUT not assigned. Free line available on JP2 jumper. Usable in output to turn on the LED'
            )
        )


if __name__ == '__main__':
    userpins = UserPinList()
    print userpins.vars[0].name

